<?php
//sortabletable.inc.php 0.3	'06.11.18		taru
//sortabletable.inc.php R00 '19.07.25

/*

  Name
    sortabletable.inc.php (with "DataTables")
	sortabletableR

  Licence
    GPLv2 or (at your option) any later version

  Licence Text
    GPlv2: https://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html
    GPLv3: https://www.gnu.org/licenses/gpl-3.0.en.html

*/

/*

  DataTables | MIT license

  DataTables is available under the MIT license. In short, this means that you are free to use
  DataTables as you wish, including modifying and redistributing the code, as long as the original
  copyright notice is retained.
  
  MIT license
  Copyright (C) 2008-2019, SpryMedia Ltd.

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
  associated documentation files (the "Software"), to deal in the Software without restriction, including
  without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to
  the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or substantial
  portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/

function sortabletable_main($table_id, $table_html, $sortabletableso, $filter_set)
{
	global $script;
	static $st_count = 0;

	if ($st_count == 0) {
		global $head_tags;
//		$head_tags[] = ' <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>';
		$head_tags[] = ' <script type="text/javascript" src="skin/DataTables/datatables.js"></script>';
		$head_tags[] = ' <script type="text/javascript" src="skin/DataTables/dataTables.buttons.js"></script>';
		$head_tags[] = ' <script type="text/javascript" src="skin/DataTables/jszip.js"></script>';
		$head_tags[] = ' <script type="text/javascript" src="skin/DataTables/buttons.html5.js"></script>';
		$head_tags[] = ' <script type="text/javascript" src="skin/DataTables/currency.js"></script>';
		$head_tags[] = ' <link rel="stylesheet" href="skin/DataTables/datatables.css">';
		$head_tags[] = ' <link rel="stylesheet" href="skin/DataTables/buttons.dataTables.css">';
		$head_tags[] = ' <link rel="stylesheet" href="skin/DataTables/custom.datatables.css">';
	}
	$st_count++;

	$table_html = preg_replace('/<table class="style_table"/', '<table id="' . $table_id . '" class="style_table"', $table_html);

	$js = <<<EOD
<script>
$(document).ready(function(){
  $('#$table_id').DataTable({
	language:{url: "https://cdn.datatables.net/plug-ins/1.10.19/i18n/Japanese.json"},
	dom:'Bflrtip',
	buttons:['copyHtml5','csvHtml5','excelHtml5'],
	lengthMenu:[500,100,50,10,1],
	order:[],
	columnDefs:[$sortabletableso],
	$filter_set
  });
});
</script>
EOD;

	return $table_html . $js;
}

function plugin_sortabletable_convert()
{
	static $number = array();

	$page = isset($vars['page']) ? $vars['page'] : '';

	if (! isset($number[$page])) $number[$page] = 1;
	$count = $number[$page]++;
	
	$args = func_get_args();

	$t_source = array_pop($args);
	$t_source = str_replace("\r", "\n", str_replace("\r\n", "\n", $t_source));

	if (isset($args[0]) && $args[0] != ""){
		$st_so = explode("|", $args[0]);
		$st_so = str_ireplace('sort=','',$st_so);
		$st_so = str_ireplace('off','Off',$st_so);
//		$st_so = str_ireplace(' ',' ',$st_so);
		$st_so = str_ireplace('number','Number',$st_so);
		$st_so = str_ireplace('string','String',$st_so);
		$st_so = str_ireplace('secret','Secret',$st_so);

		$td_start = array_shift($st_so);
		
		switch($td_start){
			case 'Off':
				$sortabletableso = "{ targets:0, orderable:false }, ";
				break;
//			case ' ':
//				$sortabletableso = "{ targets:0, orderDataType:' ' }, ";
//				break;
			case 'Number':
				$sortabletableso = "{ targets:0, type:'currency' }, ";
				break;
			case 'String':
				$sortabletableso = "{ targets:0, type:'string' }, ";
				break;
			case 'Secret':
				$sortabletableso = "{ targets:0, visible:false }, ";
				break;
			default:
				$sortabletableso = "{ targets:0, orderable:true }, ";
		}

		foreach ($st_so as $st_so_c) {
			$td_count++;
				switch($st_so_c){
					case 'Off':
						$sortabletableso .= "{ targets:" . $td_count . ", orderable:false }, ";
						break;
//					case ' ':
//						$sortabletableso .= "{ targets:" . $td_count . ", orderDataType:' ' }, ";
//						break;
					case 'Number':
						$sortabletableso .= "{ targets:" . $td_count . ", type:'currency' }, ";
						break;
					case 'String':
						$sortabletableso .= "{ targets:" . $td_count . ", type:'string' }, ";
						break;
					case 'Secret':
						$sortabletableso .= "{ targets:" . $td_count . ", visible:false }, ";
						break;
					default:
						$st_so_c = 'true';
				}
		}
		
		$sortabletableso  = substr($sortabletableso,0,-2);

	}

	switch($args[1]){
		case '2':
			$filter_set = 'bAutoWidth:false';
			break;
		case '1':
			$filter_set = 'bAutoWidth:false, bInfo:false, bLengthChange:false, bPaginate:false';
			break;
		default:
			$filter_set = 'bAutoWidth:false, bFilter:false, bInfo:false, bLengthChange:false, bPaginate:false';
	}
		
	if (isset($args[2]) && $args[2] != ""){
		$table_id = $args[2] . $count;
	} else {
		$table_id = 'DataTables' . $count;
	}

	$h_t_source = convert_html($t_source);

	$body = sortabletable_main( $table_id, $h_t_source, $sortabletableso, $filter_set);

	return $body;

}

?>
